#delimit ;
clear;
clear matrix;
set linesize 95;
set more off;
 
capture log close;
log using "dk_wind_data.log", replace;

use "dk_turbines_2012.dta", clear;
drop prod_year* prod_month* grid_type;
sort tref;
compress;
desc;
saveold "dk_turbines.dta", replace;

use "dk_turbines_2012.dta", clear;
gen year=2012;
egen etest=rowtotal(prod_month*);
drop if etest==. | etest==0;
drop prod_year* grid_type etest;
sort tref;
compress;
saveold "temp2012.dta", replace;

forval i=2002/2011 {;
	use "dk_output_`i'.dta", clear;
	gen year=`i';
	sort tref;
	merge tref using "dk_turbines.dta";
	tab _merge;
	drop if _merge != 3;
	drop _merge;
	sort tref;
	compress;
	saveold "temp`i'.dta", replace;
};

use "temp2002.dta", clear;
forval i=2003/2012 {;
	append using "temp`i'.dta";
};
gen syear=year(sdate);
gen smonth=month(sdate);
gen fyear=year(fdate);
gen fmonth=month(fdate);
gen onshore=0;
replace onshore=1 if loc_type=="LAND";
sort tref year;
drop P loc_type cad_district cad_ref x_coord y_coord 
     rdiam hheight;
forval j=1/12 {;
	replace prod_month`j'=int(prod_month`j');
};

order tref year syear smonth sdate fyear fmonth fdate cap_kw 
      onshore manuf type lanumb laname distrib_ref;
compress;
desc;
saveold dk_wind_data.dta, replace;

log close;
exit;
