#delimit ;
clear;
clear matrix;
set linesize 95;
set more off;
 
capture log close;
log using "dk_windfarm_output.log", replace;

use "dk_wind_data.dta", clear;
drop if fyear==2002 | syear < 1990 | year < syear | year > fyear;
gen nturb=1;
collapse (sum) nturb cap_kw prod_month*, 
         by(syear smonth fyear fmonth onshore lanumb laname manuf type year);
sort syear smonth fyear fmonth onshore lanumb laname manuf type year;
gen wref=_n;
replace wref=wref[_n-1] if syear==syear[_n-1] & smonth==smonth[_n-1] 
        & fyear==fyear[_n-1] & fmonth==fmonth[_n-1] & onshore==onshore[_n-1]
        & lanumb==lanumb[_n-1] & laname==laname[_n-1]
        & manuf==manuf[_n-1] & type==type[_n-1];

reshape long prod_month, j(month)
        i(year wref);
drop if (year==syear & month <= smonth) | (year==fyear & month >= fmonth)
        | (year==2012 & month >= 9); 
gen period=12*(year-1980)+month;
gen speriod=12*(syear-1980)+smonth;
gen mage=period-speriod;
gen yage=max(int((mage-1)/12),0);
gen mday=31;
replace mday=28 if month==2;
replace mday=29 if month==2 & (year==2004 | year==2008 | year==2012);
replace mday=30 if month==4 | month==6 | month==9 | month==11;
gen cap_mw=cap_kw/1000;
gen mwh_prod=prod_month/1000;
gen mwh_cap=(cap_kw*mday*24)/1000;
gen load_fact=100*mwh_prod/mwh_cap;
replace load_fact=. if mage==0 | load_fact >= 100;

** Drop small & old wind farms;
drop if cap_mw < 1 | syear < 1992;

** Drop cases for which the number of turbines is reduced after operating for some years;
drop if wref==16649 & year >= 2012;
** Drop initial observations for wind farms that were expanded; 
drop if wref==23371 & year < 2005;
drop if wref==22599 & year==2002;

sum load_fact if yage==0, detail;
sum load_fact if yage==1, detail;

drop prod_month cap_kw;
sort wref year month;
order wref year month period nturb syear smonth speriod mage yage
      fyear fmonth onshore lanumb laname manuf type
      cap_mw mwh_prod mwh_cap load_fact mday;
compress;
desc;
saveold "dk_windfarm_output.dta", replace;

log close;
exit;
